228. 异或
题目链接
228. 异或
两个非负整数的 \(XOR\) 是指将它们表示成二进制数,再在对应的二进制位进行 \(XOR\) 运算。
现在,定义 \(K\) 个非负整数 \(A_1,A_2,…,A_K\) 的 \(XOR\) 和为:
\(A_1\ XOR\ A_2\ XOR\ …\ XOR\ A_K\)
考虑一个边权为非负整数的无向连通图,节点编号 \(1\) 到 \(N\),试求出一条从 \(1\) 号节点到 \(N\) 号节点的路径,使路径上经过的边的权值的 \(XOR\) 和最大。
路径可以重复经过某些点或边,当一条边在路径中出现了多次时,其权值在计算 \(XOR\) 和时也要被计算相应多的次数。
输入格式
第一行包含两个整数 \(N\) 和 \(M\),表示该无向图中点的数目与边的数目。
接下来 \(M\) 行描述 \(M\) 条边,每行三个整数 \(S_i,T_i ,D_i\),表示 \(S_i\) 与 \(T_i\) 之间存在一条权值为 \(D_i\) 的无向边。
图中可能有重边或自环。
输出格式
仅包含一个整数,表示最大的 \(XOR\) 和(十进制结果),注意输出后加换行回车。
数据范围
\(N \le 50000 , M \le 100000, D_i \le 10^{18}\)
输入样例:
5 7
1 2 2
1 3 2
2 4 1
2 5 1
4 5 3
5 3 4
4 3 2
输出样例:
6
解题思路
线性基
由于使用环即将方向换为另外一个方向,故任意一条 \(1\) 到 \(n\) 的路径都可以由一条 \(1\) 到 \(n\) 的路径加上若干个环表示出来,所以问题转化为任取一条 \(1\) 到 \(n\) 的路径,然后取若干个环使异或和最大,故可先固定一条 \(1\) 到 \(n\) 的路径表示的异或和,然后选取若干个环,可用线性基表示环的异或空间,最后逆序贪心选取线性基元素即可
- 时间复杂度:\(O(63m+n)\)
代码
// Problem: 异或
// Contest: AcWing
// URL: https://www.acwing.com/problem/content/230/
// Memory Limit: 64 MB
// Time Limit: 1000 ms
//
// Powered by CP Editor (https://cpeditor.org)
// %%%Skyqwq
#include <bits/stdc++.h>
//#define int long long
#define help {cin.tie(NULL); cout.tie(NULL);}
#define pb push_back
#define fi first
#define se second
#define mkp make_pair
using namespace std;
typedef long long LL;
typedef pair<int, int> PII;
typedef pair<LL, LL> PLL;
template <typename T> bool chkMax(T &x, T y) { return (y > x) ? x = y, 1 : 0; }
template <typename T> bool chkMin(T &x, T y) { return (y < x) ? x = y, 1 : 0; }
template <typename T> void inline read(T &x) {
int f = 1; x = 0; char s = getchar();
while (s < '0' || s > '9') { if (s == '-') f = -1; s = getchar(); }
while (s <= '9' && s >= '0') x = x * 10 + (s ^ 48), s = getchar();
x *= f;
}
const int N=50005;
int n,m;
LL d[N],a[65];
bool v[N];
vector<pair<int,LL>> adj[N];
void insert(LL x)
{
for(int i=62;i>=0;i--)
if(x>>i&1)
{
if(!a[i])
{
a[i]=x;
break;
}
else
x^=a[i];
}
}
void dfs(int x)
{
v[x]=true;
for(auto t:adj[x])
{
int y=t.fi;
LL w=t.se;
if(!v[y])d[y]=d[x]^w,dfs(y);
else
insert(d[y]^w^d[x]);
}
}
int main()
{
help;
cin>>n>>m;
for(int i=1;i<=m;i++)
{
int x,y;
LL z;
cin>>x>>y>>z;
adj[x].pb({y,z}),adj[y].pb({x,z});
}
dfs(1);
LL res=d[n];
for(int i=62;i>=0;i--)res=max(res,res^a[i]);
cout<<res;
return 0;
}